package javamath.hasse.lattice;

import java.util.*;
import javamath.hasse.util.*;

public class ChainDecomposition {

  int numChains;	// number of chains
  Hashtable chain_ht;	// the keys are the labels of the elements;
			// the values are int's telling what chain 
			// the elem is in.

  public ChainDecomposition(OrderedSet poset) {
    
    Integer h = new Integer(0);
    Hashtable visited = new Hashtable(poset.card());
    Hashtable chain_ht = new Hashtable(poset.card());
    Vector elems = poset.univ();
    Enumeration list; 
    Boolean True = new Boolean(true);
    Boolean False = new Boolean(false);

    list = elems.elements();
    while (list.hasMoreElements()) {
      visited.put(((POElem)list.nextElement()).label(), False);
    }
    list = elems.elements();
    while (list.hasMoreElements()) {
      POElem x = (POElem)list.nextElement();
      if (False == visited.get(x.label())) {
        visited.put(x.label(), True);
	chain_ht.put(x.label(), h);
        Enumeration uc = x.upperCovers().elements();
	while (uc.hasMoreElements()) {
	  POElem y = (POElem)uc.nextElement(); 
	  if (False == visited.get(y.label())) {
            visited.put(y.label(), True);
	    chain_ht.put(y.label(), h);
	    uc = y.upperCovers().elements();
	    x = y;
	  }
	}
	h = new Integer(1 + h.intValue());
      }
    }
    numChains = h.intValue();
    this.chain_ht = chain_ht;
  }
  public int numChains() {
    return numChains;
  }
  public Hashtable getHashtable() {
    return chain_ht;
  }
  public int chainNum(POElem x) {
    return ((Integer)chain_ht.get(x.label())).intValue();
  }
}
    
