package uacalc.alg.opedit;

import uacalc.alg.Operation;
import uacalc.alg.OpArguments;
import uacalc.util.WholeNumberField;

import uacalc.ex.TooManyArgumentsException;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.beans.*;

public class OpValueReader extends JDialog {
//This is not really a class, could be a function.
//It is assumed that the arity of f is already correctly set.

    public OpValueReader(Frame parent, Operation f) {
	
        super(parent, true);
	//This doesn't work for some reason, the dialog is not
	//centered over this frame. A partial solution is the next command:
	setLocationRelativeTo(parent);
    
	setTitle("Value input");
	m_f= f;
	m_arity = f.getArity();
	m_size = f.getSize();
	try {
	    Args = new OpArguments(m_arity);
	} catch(TooManyArgumentsException e) {
	    System.out.println("Impossible TooManyArgumentsException");
	}
	prompt = new JLabel(f.getNameString() + "(" +
	    Args.toString() + ") = ");
    
        final WholeNumberField NumberField = new WholeNumberField(
	    f.getValue(Args), 0);

//We have to decide whether to display the arguments and the value input field
//in two different rows. Currently this is so. If they are in the same row,
//then the beginning of the input field is jumping depending on the current
//argument values.

//	JPanel pane = new JPanel();
//	pane.setLayout(new BoxLayout(pane, BoxLayout.X_AXIS));
//	pane.add(prompt);
//	pane.add(NumberField);

        Object[] array = {//"Please enter the value.",
//			  pane
			  prompt,
			  NumberField
	};

        final String btnString1 = "Next";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        optionPane = new JOptionPane(array, 
				     JOptionPane.QUESTION_MESSAGE,
				     JOptionPane.OK_CANCEL_OPTION,
				     null,
				     options,
				     options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	optionPane.setValue(
	    JOptionPane.UNINITIALIZED_VALUE);

        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
		}
		public void windowActivated(WindowEvent e) {
		    NumberField.requestFocus();
		}
        });

        NumberField.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    optionPane.setValue(btnString1);
		}
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object v = optionPane.getValue();

                    if (v == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (v.equals(btnString1)) {
                            int value = NumberField.getValue();
                        if (value >= 0 && value < m_size) {
			    m_f.setValue(Args, value);
			    if(!Args.incr_arguments(m_size)) {
				//We are done
				m_f.setValid(true);
				setVisible(false);
			    }	else {
				prompt.setText(m_f.getNameString() + "(" +
				  Args.toString() + ") = ");
				NumberField.setValue(m_f.getValue(Args));
				NumberField.requestFocus();
				return;
			    }
                        } else { 
                            // number was invalid
                            NumberField.selectAll();
			    NumberField.requestFocus();
                            JOptionPane.showMessageDialog(
                                            OpValueReader.this,
					    "Please enter a number between " +
					    0 + " and " + (m_size-1) + ".",
					    "Number out of bounds",
                                            JOptionPane.ERROR_MESSAGE);
                        }
                    } else { 
                        // user closed dialog or clicked cancel
			int ans = JOptionPane.showConfirmDialog(
			    OpValueReader.this, 
			    "Are you sure you want to abandon adding a new operation?",
			    "Confirm",
			    JOptionPane.YES_NO_OPTION,
			    JOptionPane.QUESTION_MESSAGE);
			if(ans != JOptionPane.YES_OPTION) return;
			setVisible(false);
                    }
                }
            }
        });
	pack();
	NumberField.selectAll();
        setVisible(true);
    }

    private Operation m_f;
    private int m_size;
    private int m_arity;
    private JLabel prompt;
    private JOptionPane optionPane;
    private OpArguments Args;
}
