package uacalc.alg.opedit;

import uacalc.alg.Operation;
import uacalc.alg.OpArguments;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

public abstract class OperationRenderer {

    public OperationRenderer(Operation f,
			     ValueEditor editor,
			     Container pane) {

	m_f = f;
	m_editor = editor;
	m_pane = pane;
	m_size = f.getSize();
	m_arity = f.getArity();

    }

    public void OnInvalidValue(final OpArguments args,
			       final int value) {

	JOptionPane.showMessageDialog(
	    m_pane,
	    "Please enter a number between " +
	    0 + " and " + (m_size-1) + ".",
	    "Value out of bounds",
	    JOptionPane.ERROR_MESSAGE);
	
	SwingUtilities.invokeLater( new Runnable () { 
		public void run (){ 
		    editValueAt(args, value);
		}
	    }); 
    }

    public void OperationChanged() {
	m_editor.enableSaveMenu();
    }

    protected Operation m_f;
    protected Container m_pane;
    protected int m_size;
    protected int m_arity;
    private ValueEditor m_editor;

    public abstract void editValueAt(OpArguments args, int defaultValue);
    public abstract void editValueAt(OpArguments args);
    public abstract void Update();
    public abstract boolean isEditorOpen();

}
