package uacalc.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.beans.*;

public class ewkGetNumberDialog extends JDialog {


    public ewkGetNumberDialog(Frame parent, String message,
			      int value, int min, int max ) {
//value is the default value.
//set it to -1 to display the empty string initially.

        super(parent, true);
	//This doesn't work for some reason, the dialog is not
	//centered over this frame. A partial solution is the next command:
	setLocationRelativeTo(parent);

        setTitle("Get Number");
	m_value= value;
	m_min = min;
	m_max = max;

        final WholeNumberField NumberField = 
	    new WholeNumberField(m_value, 0);
        Object[] array = {message, NumberField};

        final String btnString1 = "Done";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        optionPane = new JOptionPane(array, 
				     JOptionPane.QUESTION_MESSAGE,
				     JOptionPane.OK_CANCEL_OPTION,
				     null,
				     options,
				     options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	optionPane.setValue(
	    JOptionPane.UNINITIALIZED_VALUE);

        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
		}
		public void windowActivated(WindowEvent e) {
		    NumberField.requestFocus();
		}
        });

        NumberField.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    optionPane.setValue(btnString1);
		}
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object v = optionPane.getValue();

                    if (v == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (v.equals(btnString1)) {
                            m_value = NumberField.getValue();
                        if (m_value >= m_min && m_value <= m_max) {
                            // we're done; dismiss the dialog
                            setVisible(false);
                        } else { 
                            // number was invalid
                            NumberField.selectAll();
			    NumberField.requestFocus();
                            JOptionPane.showMessageDialog(
                                            ewkGetNumberDialog.this,
					    "Please enter a number between " +
					    m_min + " and " + m_max + ".",
					    "Number out of bounds",
                                            JOptionPane.ERROR_MESSAGE);
                        }
                    } else { 
                        // user closed dialog or clicked cancel
			m_value = -1;
			setVisible(false);
                    }
                }
            }
        });
	pack();
	NumberField.selectAll();
        setVisible(true);
    }

    public int getValidatedNumber() {
        return m_value;
    }

    private int m_value;
    private int m_min;
    private int m_max;
    private JOptionPane optionPane;

}
