package uacalc.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.beans.*;

public class ewkGetTextDialog extends JDialog {

    public ewkGetTextDialog(JFrame parent, String message,
			       String title, String initValue) {

        super(parent, true);
	//This doesn't work for some reason, the dialog is not
	//centered over this frame. A partial solution is the next command:
	setLocationRelativeTo(parent);

        setTitle(title);

	area = new JTextArea(initValue, 10, 60);
	area.setEditable(true);
        area.setLineWrap(true);
	area.setWrapStyleWord(true);
	pane = new JScrollPane(area);
        Object[] array = {message, pane};

        final String btnString1 = "Done";
        Object[] options = {btnString1};

        optionPane = new JOptionPane(array, 
				     JOptionPane.PLAIN_MESSAGE,
				     JOptionPane.DEFAULT_OPTION,
				     null,
				     options,
				     options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	optionPane.setValue(
	    JOptionPane.UNINITIALIZED_VALUE);

        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
		}
		public void windowActivated(WindowEvent e) {
		    area.requestFocus();
		}
        });


        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object v = optionPane.getValue();

                    if (v == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (v.equals(btnString1)) {
			// we're done; dismiss the dialog
			setVisible(false);
                    } else { 
                        // user closed dialog or clicked cancel
			setVisible(false);
                    }
                }
            }
        });


	pack();
        setVisible(true);
    }

    public String getEnteredText() {
        return area.getText();
    }

    private JOptionPane optionPane;
    private JTextArea area;
    private JScrollPane pane;
}
